#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define BUFFSIZE 8192

int main(int argc, char* argv[]) {
    int n, srcFd, dstFd, dstOffset;
    char buf[BUFFSIZE];
    
    if (argc == 1){
        printf("kopiraj <srcFile> <dstFile> [<dstOffset>]");
        exit(0);
    }
    
    if (argc < 3){ //treba barem ime dviju datoteka
        printf("Incorect number of arguments!");
        exit(1);
    }
    
    if (argc < 4){
        dstOffset = 0;
    }else{
	dstOffset = atoi(argv[3]);
    }
    
    srcFd = open(argv[1], O_RDONLY);
    if (srcFd == -1)
        perror("open");
    
    dstFd = creat(argv[2], (mode_t)0644);
    if (dstFd == -1)
        perror("creat");

    if (lseek(dstFd, dstOffset, SEEK_SET) != dstOffset)
        perror("lseek");        
    
    while((n=read(srcFd, buf, BUFFSIZE)) > 0) {
        if (write(dstFd, buf, n) != n)
            perror("write");
    }
    if (n<0)
        perror("read");
    exit(0);
}
